//Datablocks by Demian (10334)
datablock ShapeBaseImageData(IM_jetPackTool_Modern_Mounted) //Image when mounted
{
	shapeFile = "./modern.dts";
	mountPoint = 2; //BackSlot
	offset = "0 -0.21 -0.35";
	eyeOffset = "0 0 10 1"; //Not visible in first person
	rotation = eulerToMatrix("0 0 180");
	scale = "1 1 1";
	doColorShift = true;
	colorShiftColor = "0.9 0.9 0.9 1";
	
	lightType = "NoLight";
	
	stateName[0]				= "Activate";
	stateTimeoutValue[0]		= 0.1;
	stateTransitionOnTimeout[0]	= "Ready";

	stateName[1]					= "Ready";
	stateAllowImageChange[1]		= true;
	stateTransitionOnLoaded[1]		= "Fire";
	stateTransitionOnNotLoaded[1]	= "Ready";

	stateName[2]					= "Fire";
	stateScript[2]					= "checkEnergyLevel";
	stateAllowImageChange[2]		= true;
	stateEmitterNode[2]				= emitterPoint;
	stateEmitterTime[2]				= 0.15;
	stateEmitter[2]					= EM_jetPackFire;
	stateTimeoutValue[2]			= 0.05;
	stateTransitionOnNotLoaded[2]	= "Ready";
	stateTransitionOnTimeout[2]		= "Fire2";

	stateName[3]					= "Fire2";
	stateScript[3]					= "checkEnergyLevel";
	stateAllowImageChange[3]		= true;
	stateEmitterNode[3]				= emitterPoint2;
	stateEmitterTime[3]				= 0.15;
	stateEmitter[3]					= EM_jetPackFire;
	stateTimeoutValue[3]			= 0.05;
	stateTransitionOnNotLoaded[3]	= "Ready";
	stateTransitionOnTimeout[3]		= "Fire";
};

datablock ShapeBaseImageData(IM_jetPackTool_Modern) //Image when in hand
{
	shapeFile = "./modern.dts";
	Item = "IT_jetPackTool_Modern";

	firstPersonParticles = false;
	armReady = true;
	
	mountPoint = 0; //Right hand
	offset = "0 0 0";
	rotation = eulerToMatrix("0 0 0");
	eyeOffset = "0 0 0 0";
	eyeRotation = "0 0 0 0";

	doColorShift = true;
	colorShiftColor = "0.9 0.9 0.9 1";
	
	lightType = "NoLight";
	
	stateName[0]					= "Active";
	stateTimeoutValue[0]			= 0.03;
	stateTransitionOnTriggerDown[0] = "Ready";
	stateWaitForTimeout[0]			= true;

	stateName[1]				  = "Ready";
	stateAllowImageChange[1]	  = false;
	stateTimeoutValue[1]		  = 0.03;
	stateTransitionOnTriggerUp[1] = "Equip";
	stateWaitForTimeout[1]		  = true;

	stateName[2]				= "Equip";
	stateAllowImageChange[2]	= true;
	stateScript[2]				= "onFire";
	stateTimeoutValue[2]		= 0.03;
	stateTransitionOnTimeout[2] = "Ready";
	stateWaitForTimeout[2]		= true;
};

datablock ItemData(IT_jetPackTool_Modern)
{
	shapeFile = "./modern.dts";
	image = "IM_jetPackTool_Modern";
	rotate = false;
	
	uiName = "Modern Jetpack";
	iconName = "./Icon_jetPackModern";
	canDrop = true;
	jetPackTool = true;

	mass = 1;
	drag = 0.5;
	density = 0.2;
	friction = 0.6;
	elasticity = 0.2;
	gravityMod = 1;

	doColorShift = true;
	colorShiftColor = "0.9 0.9 0.9 1";
	
	lightType = "NoLight";
};

//Functions originally by Moppy (21868), modified by Demian (10334) and Daenth (951)
function IM_jetPackTool_Modern::onFire(%this, %obj, %slot)
{
	%client=%obj.client;
	if(!%obj.Wear)
	{
		%obj.Wear = 1;
		
		for(%i = 0;$backpack[%i] !$= "";%i++)
		{
			%obj.hideNode($backpack[%i]);
		}
		%obj.unMountImage(2);
		%obj.mountimage(IM_jetPackTool_Modern_Mounted, 2);
		%obj.setImageLoaded(2,0);
		%obj.previousDatablock = %obj.getDatablock();

		if($Pref::JetPackTool::UseFuel)
		{
			%obj.changeDatablock(Player_JetpackFuel);
		}
		else
		{
			%obj.changeDatablock(Player_Jetpack);
		}

		%obj.unMountImage(0);
		%obj.mountimage(IM_JPT_Modern_Empty,0);
		%obj.schedule(0,"playThread",2,shiftAway);
		%obj.schedule(190,"playThread",1,root);
	}
}

datablock ShapeBaseImageData(IM_JPT_Modern_Empty : IM_jetPackTool_Modern)
{
	shapeFile = "base/data/shapes/empty.dts";
	armReady = false;
};

function IM_JPT_Modern_Empty::onFire(%this, %obj, %slot)
{
	%client=%obj.client;
	if(%obj.Wear)
	{
		%obj.Wear = 0;

		%obj.unMountImage(2);
		%obj.unMountImage(0);
		%obj.mountimage(IM_jetPackTool_Modern,0);
		%obj.changeDatablock(%obj.previousDatablock);
		%obj.previousDatablock = "";
		%obj.playThread(2, shiftAway);
		%obj.playThread(1, armReadyRight);

		%client.applyBodyParts();
		%client.applyBodyColors();
	}
}

function IM_jetPackTool_Modern::onMount(%this, %obj, %slot)
{
	if(%obj.Wear)
	{
		%obj.unMountImage(0);
		%obj.mountimage(IM_JPT_Modern_Empty,0);
	}
}

function IM_jetPackTool_Modern_Mounted::checkEnergyLevel(%this,%obj,%slot)
{
	if(%obj.getEnergyLevel() < 1)
		%obj.setImageLoaded(2,0);
}