//We need the Fuel Jet and No-Jet players.
%error = ForceRequiredAddOn("Player_Fuel_Jet");
if(%error == $Error::AddOn_Disabled)
{
	PlayerFuelJet.uiName = "";
}

if(%error == $Error::AddOn_NotFound)
{
   error("ERROR: Tool_Jetpack - required add-on Player_Fuel_Jet not found");
}

%error = ForceRequiredAddOn("Player_No_Jet");
if(%error == $Error::AddOn_Disabled)
{
	PlayerNoJet.uiName = "";
}

if(%error == $Error::AddOn_NotFound)
{
   error("ERROR: Tool_Jetpack - required add-on Player_No_Jet not found");
}

//Checking for RTB.
if (isFile("Add-Ons/System_ReturnToBlockland/server.cs")) 
{
	if(!$RTB::RTBR_ServerControl_Hook)
	{
		exec("Add-Ons/System_ReturnToBlockland/hooks/serverControl.cs");
	}
	RTB_registerPref("Jetpack Fuel", "Jetpack Tool",  "$Pref::JetPackTool::PlayerFuel", "int 0 60000", "Tool_Jetpack",  100, true, false, "");
	RTB_registerPref("Use Fuel", "Jetpack Tool",  "$Pref::JetPackTool::UseFuel", "bool", "Tool_Jetpack",  true, false, false, "");
}
else //RTB not found, defining prefs for non-RTB users.
{
	$Pref::JetPackTool::PlayerFuel = 100;
	$Pref::JetPackTool::UseFuel = true;
}

//Script by Moppy (21868), with minor changes by Demian (10334), for mounting/unmounting the jetpack image.
package jetPackTool
{
	function serverCmdDropTool(%client,%slot)
	{
		%player = %client.player;
	
		if (isObject(%player) && %player.getState() !$= "Dead")
		{
			if(nameToID(%player.tool[%slot]).jetPackTool)
			{
				if(%player.Wear)
				{
					%player.Wear = 0;
					%player.unMountImage(2); //BackSlot
					%player.unMountImage(0);
					%player.changeDatablock(%player.previousDatablock);
					%player.previousDatablock = "";
					%client.applyBodyParts();
					%client.applyBodyColors();
				}
			}
		}
		parent::serverCmdDropTool(%client,%slot);
	}
};
activatePackage(jetPackTool);

//Script by Daenth (951) for mounting the emitters to the jetpack.
package jetPackEmitter
{
	function Armor::onTrigger(%datablock,%player,%slot,%val) 
	{
		//Armor::onTrigger is called whenever a player jumps, jets, crouches, etc.
		//Each of these actions is assigned to a particular slot.
		//The jet slot is 4 and because this function is called when a variety of actions are performed, we want to make sure the jet action triggered this function.
		if(%slot == 4) 
		{
			//%val is a boolean stating whether or not action is occurring or not. 
			//If %val is 1 then jets are on.
			if(%val && %player.getEnergyLevel() > 0) 
			{
				if(%player.getMountedImage(2) == nameToID(IM_jetPackTool_Modern_Mounted) || %player.getMountedImage(2) == nameToID(IM_jetPackTool_Lego_Mounted)) 
				{
					%player.setImageLoaded(2,1); //Slot is 2 ($BackSlot), and we are setting the ammo to 1 so it has ammo.
				}
			}
			//If %val is 0 then jets are not on.
			else 
			{
				if(%player.getMountedImage(2) == nameToID(IM_jetPackTool_Modern_Mounted) || %player.getMountedImage(2) == nameToID(IM_jetPackTool_Lego_Mounted))
				{
					%player.setImageLoaded(2,0); //Slot is 2 ($BackSlot), and we are setting the ammo to 0 so it has no ammo.
				}
			}
		}
		return Parent::onTrigger(%datablock,%player,%slot,%val);
	}
};
activatePackage(jetPackEmitter);

//Particles + emitters (by Demian (10334)) shared by the two jetpacks.
datablock ParticleData(PA_jetPackFire)
{
	textureName = "base/data/particles/dot";
	animateTexture = false;
	useInvAlpha = false;

	lifetimeMS = 135;
	lifetimeVarianceMS = 0;

	spinSpeed = 0.0;
	spinRandomMin = 0.0;
	spinRandomMax = 0.0;

	inheritedVelFactor = 1.0;
	dragCoefficient = 0.0;
	gravityCoefficient = 0.0;
	windCoefficient = 0.0;
	constantAcceleration = 0.0;

	colors[0] = "0.0 0.0 1.0 1.0";
	colors[1] = "1.0 0.5 0.0 1.0";
	colors[2] = "1.0 0.0 0.0 0.0";
	colors[3] = "1.0 1.0 1.0 1.0";

	sizes[0] = "0.365";
	sizes[1] = "0.38";
	sizes[2] = "0.0";
	sizes[3] = "0.0";

	times[0] = "0.0";
	times[1] = "0.2";
	times[2] = "1.0";
	times[3] = "1.0";
};

datablock ParticleEmitterData(EM_jetPackFire)
{
	className = "ParticleEmitterData";

	uiName = "Jetpack Fire";
	particles = PA_jetPackFire;
	
	lifetimeMS = 0;
	lifetimeVarianceMS = 0;

	ejectionOffset = 0.0;
	ejectionPeriodMS = 6.0;
	periodVarianceMS = 0.0;
	ejectionVelocity = 6.5;
	velocityVariance = 1.0;

	orientParticles = false;
	orientOnVelocity = true;

	phiReferenceVel = 0.0;
	phiVariance = 0.0;
	thetaMin = 0.0;
	thetaMax = 0.0;

	useEmitterColors = false;
	useEmitterSizes = false;

	overrideAdvance = false;
	doFalloff = true;
	doDetail = true;
};

//Execute the rest of the stuff
exec("./player.cs");
exec("./gas.cs");
exec("./jetpack_modern.cs");
exec("./jetpack_lego.cs");